//+------------------------------------------------------------------+
//|                                             InsideOutsideBar.mq5 |
//|                                       Oleg Fedorov (aka certain) |
//|                                   mailto:coder.fedorov@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Oleg Fedorov (aka certain)"
#property link      "mailto:coder.fedorov@gmail.com"
#property version   "1.00"
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_plots   2
//--- plot Up
#property indicator_label1  "Up"
#property indicator_type1   DRAW_ARROW
#property indicator_color1  clrMediumPurple
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
//--- plot Down
#property indicator_label2  "Down"
#property indicator_type2   DRAW_ARROW
#property indicator_color2  clrMediumPurple
#property indicator_style2  STYLE_SOLID
#property indicator_width2  1

enum BarsTypeSelector
 {
  Inside  = 0, // Inside bar
  Outside = 1  // Outside bar
 };
//--- input parameters
input BarsTypeSelector      inp_barsTypeSelector=Inside;
input int                   inp_arrowCode=159;
input int                   inp_arrowShift=5;
//--- indicator buffers
double         UpBuffer[];
double         DownBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
 {
//--- indicator buffers mapping
  SetIndexBuffer(0,UpBuffer,INDICATOR_DATA);
  SetIndexBuffer(1,DownBuffer,INDICATOR_DATA);
//--- set a code from the Wingdings charset as the property of PLOT_ARROW
  PlotIndexSetInteger(0,PLOT_ARROW,inp_arrowCode);
  PlotIndexSetInteger(1,PLOT_ARROW,inp_arrowCode);

//--- set arrow shift
  PlotIndexSetInteger(0, PLOT_ARROW_SHIFT, -inp_arrowShift);
  PlotIndexSetInteger(1, PLOT_ARROW_SHIFT, inp_arrowShift);

//---
  return(INIT_SUCCEEDED);
 }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
 {
//--- Variables descriptions
  int i,     
      start; 

  const int barsInPattern = 2; 

//--- Initialize some limits
  if(rates_total < barsInPattern)
    return(0); 

  if(prev_calculated < barsInPattern+1) 
   {
    start = barsInPattern;  
   }
  else
    start = rates_total - barsInPattern; 
                                         
//--- Initialize last bar by EMPTY_VALUE
    UpBuffer[rates_total-1] = EMPTY_VALUE;
    DownBuffer[rates_total-1] = EMPTY_VALUE;
//---
  for(i = start; i<rates_total-1; i++)
   {
    // All garbage data in arays need to be deleted in the beginning of plotting 
    UpBuffer[i] = EMPTY_VALUE;
    DownBuffer[i] = EMPTY_VALUE;
    if(inp_barsTypeSelector==Inside)
     {
      // Inside work
      if(high[i] <= high[i-1] && low[i] >= low[i-1])
       {
        UpBuffer[i-1] = high[i-1];
        DownBuffer[i-1] = low[i-1];
       }
     }
    else
     {
      // Outside work
      if(high[i] >= high[i-1] && low[i] <= low[i-1])
       {
        UpBuffer[i] = high[i];
        DownBuffer[i] = low[i];
       }
     }
   }
//--- return value of prev_calculated for next call
  return(rates_total);
 }
//+------------------------------------------------------------------+
